idx = 0; 
n = 100;

%maxPeople = 50; 
%range = 20:1:maxPeople;
range = 1:100;
err = zeros(3, length(range));
    w = randn(n, 1); 


for i = range
    idx = idx + 1; 

    X = rand(20, n);


    ltIdx = w < 0; 
    ltSum = sum(w(ltIdx)); 
    w(ltIdx) = w(ltIdx) / abs(ltSum); 
    
    gtIdx = w > 0; 
    gtSum = sum(w(gtIdx)); 
    w(gtIdx) = w(gtIdx) / gtSum; 
    
    Xcurr = X; 
    
    Y = X * w; 
    
    wOLS = pinv(Xcurr) * Y; 
    x_OLS = zeros(1,n); 
    x_OLS(wOLS > 0) = 1; 
    
    err(1,idx) =  x_OLS * w; 
    
    
    ridgeW = weirdReg(Xcurr,Y, 0.1, 0);
    x_ridge = zeros(1, n); 
    x_ridge(ridgeW > 0) = 1;
    
    err(2,idx) = x_ridge * w;  
    
    cvx_begin
        variable wCVX(n)
        minimize( norm( Xcurr * wCVX - Y, 2 ));
        subject to
            sum(wCVX) == 0;
            norm(wCVX, 2) <= sqrt(2); 
    cvx_end

    x_cvx = zeros(1, n); 
    x_cvx(wCVX > 0) = 1;

    err(3,idx) =  x_cvx * w;  
end

figure
plot(range, err(1,:), range, err(2,:),  range, err(3,:));
title('random candidates'); 
xlabel('iteration');
ylabel('score for best candidate');
legend('OLS', 'ridge', 'cvx');
